<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        
        
        
        <link rel="shortcut icon" href="img/favicon.ico">
        <title>DFG Calculation - PM4Py-mongo Documentation</title>
        <link href="css/bootstrap-custom.min.css" rel="stylesheet">
        <link href="css/font-awesome.min.css" rel="stylesheet">
        <link href="css/base.css" rel="stylesheet">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css">
        <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
        <!--[if lt IE 9]>
            <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
            <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
        <![endif]-->

        <script src="js/jquery-1.10.2.min.js" defer></script>
        <script src="js/bootstrap-3.0.3.min.js" defer></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
        <script>hljs.initHighlightingOnLoad();</script> 
    </head>

    <body>

        <div class="navbar navbar-default navbar-fixed-top" role="navigation">
            <div class="container">

                <!-- Collapsed navigation -->
                <div class="navbar-header">
                    <!-- Expander button -->
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="sr-only">Toggle navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <a class="navbar-brand" href="index.html">PM4Py-mongo Documentation</a>
                </div>

                <!-- Expanded navigation -->
                <div class="navbar-collapse collapse">
                        <!-- Main navigation -->
                        <ul class="nav navbar-nav">
                            <li >
                                <a href="index.html">Start</a>
                            </li>
                            <li >
                                <a href="import.html">Importing</a>
                            </li>
                            <li >
                                <a href="filter.html">Filtering</a>
                            </li>
                            <li class="active">
                                <a href="dfg.html">DFG Calculation</a>
                            </li>
                        </ul>

                    <ul class="nav navbar-nav navbar-right">
                        <li>
                            <a href="#" data-toggle="modal" data-target="#mkdocs_search_modal">
                                <i class="fa fa-search"></i> Search
                            </a>
                        </li>
                            <li >
                                <a rel="next" href="filter.html">
                                    <i class="fa fa-arrow-left"></i> Previous
                                </a>
                            </li>
                            <li class="disabled">
                                <a rel="prev" >
                                    Next <i class="fa fa-arrow-right"></i>
                                </a>
                            </li>
                    </ul>
                </div>
            </div>
        </div>

        <div class="container">
                <div class="col-md-3"><div class="bs-sidebar hidden-print affix well" role="complementary">
    <ul class="nav bs-sidenav">
        <li class="main active"><a href="#dfg-calculation">DFG Calculation</a></li>
            <li><a href="#frequency">Frequency</a></li>
            <li><a href="#performance">Performance</a></li>
            <li><a href="#calculate">calculate()</a></li>
            <li><a href="#get_dict">get_dict()</a></li>
    </ul>
</div></div>
                <div class="col-md-9" role="main">

<h1 id="dfg-calculation">DFG Calculation</h1>
<p>The <em>dfg</em> component of the library discussed on this page, can be used to calculate different versions of the directly-follows graph of an event log. Additionally the calculated DFG can be exported from the database and used in conjunction with PM4Py to discover process models.</p>
<p>The available variants are:</p>
<ul>
<li>Frequency</li>
<li>Performance</li>
</ul>
<h4 id="frequency">Frequency</h4>
<p>The frequency based dfg uses the number of occurrences to annotate an edge. </p>
<h4 id="performance">Performance</h4>
<p>The frequency based dfg uses the time that passed between two events to annotate the corrspoding edge. There are different possible aggregation metrics that are offered by the library:</p>
<ul>
<li><code>average</code>  - The average time between two events is used.</li>
<li><code>max</code> - The maximal observed time between two events is used.</li>
<li><code>min</code> - The minimal observed time between two events is used.</li>
</ul>
<hr />
<h2 id="calculate"><code>calculate()</code></h2>
<h3 id="description">Description</h3>
<p>Calculates the DFG of the specified collection.</p>
<h3 id="input">Input</h3>
<ul>
<li><code>database</code> - Database<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li><code>collection</code> - Collection<ul>
<li>The collection that should be filtered. </li>
</ul>
</li>
<li><code>variant</code> <em>(optional)</em> - String<ul>
<li>The variant of the DFG. This can be either <code>frequency</code> or <code>performance</code>. The default value is <code>frequency</code>.</li>
</ul>
</li>
<li><code>aggregation</code> <em>(optional)</em> - String<ul>
<li>The aggregation type that should be used when the specified variant is <code>performance</code>. Possible values are <code>average</code>, <code>max</code> and <code>min</code>. The default value is <code>average'</code>.</li>
</ul>
</li>
<li><code>result_collection</code> <em>(optional)</em> - String<ul>
<li>The name of the collection in which the dfg should be stored. The default values is <code>dfg</code>.</li>
</ul>
</li>
</ul>
<h3 id="output">Output</h3>
<p>A collection that contains a document for each edge of the dfg. The document contains a value which is representing the frequency or performance measure of the edge, depending on the chosen variant.</p>
<h3 id="notes">Notes</h3>
<p>See the page introduction for details on the supported variants and aggregation types.</p>
<hr />
<h2 id="get_dict"><code>get_dict()</code></h2>
<h3 id="description_1">Description</h3>
<p>Returns a dictionary representation of the DFG stored in the database.</p>
<h3 id="input_1">Input</h3>
<ul>
<li>
<p><code>database</code> - Database</p>
<ul>
<li>The database on which the filtering operation should be performed.</li>
</ul>
</li>
<li>
<p><code>input_collection</code> <em>(optional)</em> - String</p>
<ul>
<li>The name of a collection containing a dfg. The default value is <code>dfg</code>.</li>
</ul>
</li>
</ul>
<h3 id="output_1">Output</h3>
<p>A dictionary containing the edges of the DFG. The event pair defining an edge is used as the key, the frequency or performance measure is used as the value.</p>
<h3 id="notes_1">Notes</h3>
<p>Before this function can be applied, the dfg needs to be calculated using the <code>calculate()</code> function.</p>
<p>The resulting dictionary can be used in PM4Py, for example the DFG may be visualized or a process model may be discovered using the inductive miner.</p></div>
        </div>

        <footer class="col-md-12">
            <hr>
            <p>Documentation built with <a href="https://www.mkdocs.org/">MkDocs</a>.</p>
        </footer>
        <script>
            var base_url = ".",
                shortcuts = {"help": 191, "next": 78, "previous": 80, "search": 83};
        </script>
        <script src="js/base.js" defer></script>
        <script src="search/main.js" defer></script>

        <div class="modal" id="mkdocs_search_modal" tabindex="-1" role="dialog" aria-labelledby="Search Modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Search</h4>
            </div>
            <div class="modal-body">
                <p>
                    From here you can search these documents. Enter
                    your search terms below.
                </p>
                <form role="form">
                    <div class="form-group">
                        <input type="text" class="form-control" placeholder="Search..." id="mkdocs-search-query" title="Type search term here">
                    </div>
                </form>
                <div id="mkdocs-search-results"></div>
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div><div class="modal" id="mkdocs_keyboard_modal" tabindex="-1" role="dialog" aria-labelledby="Keyboard Shortcuts Modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Keyboard Shortcuts</h4>
            </div>
            <div class="modal-body">
              <table class="table">
                <thead>
                  <tr>
                    <th style="width: 20%;">Keys</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
                  <tr>
                    <td class="help shortcut"><kbd>?</kbd></td>
                    <td>Open this help</td>
                  </tr>
                  <tr>
                    <td class="next shortcut"><kbd>n</kbd></td>
                    <td>Next page</td>
                  </tr>
                  <tr>
                    <td class="prev shortcut"><kbd>p</kbd></td>
                    <td>Previous page</td>
                  </tr>
                  <tr>
                    <td class="search shortcut"><kbd>s</kbd></td>
                    <td>Search</td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div>

    </body>
</html>
